damage=20 --武器攻击力（基础）


local assets =
{	
	Asset("ANIM", "anim/scimitar.zip"),
	Asset("ANIM", "anim/swap_scimitar.zip"),
	Asset ("ATLAS", "images/inventoryimages/scimitar.xml")

}

local gem = {
	"redgem", "bluegem", "purplegem", "greengem", "orangegem", "yellowgem"
}

local getrandom = function()
	math.randomseed(tostring(os.time()):reverse():sub(1, 6))
	math.random(600)
	math.random(600)
	math.random(600)
	math.random(600)
	return math.random(600)
end

local function onfinished(inst)
	inst:Remove()
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_scimitar", "swap_spear")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end



local function onattack(inst, owner, target)
	local x,y,z = inst.Transform:GetWorldPosition()
	local a,b,c = target.Transform:GetWorldPosition()
	if (x-a)*(x-a) + (y-b)*(y-b) + (z-c)*(z-c) > 4.0 then
		
		owner.Transform:SetPosition(target.Transform:GetWorldPosition())
		
	end
	
	--owner.Transform:SetPosition(target.Transform:GetWorldPosition())
	--掉落宝石
	--[[local num = getrandom()
	if num <= 6 then
		local pt = target:GetPosition()
        local st_pt =  FindWalkableOffset(pt or owner:GetPosition(), math.random()*2*PI, 2, 3)
        if st_pt then
            st_pt = st_pt + pt
			local st = SpawnPrefab(gem[num])
			st.Transform:SetPosition(st_pt.x, st_pt.y, st_pt.z)
        end
	end]]--
	--掉落金币
	local num = math.random()
		if num <= 0.1 then
		local pt = target:GetPosition()
        local st_pt =  FindWalkableOffset(pt or owner:GetPosition(), math.random()*2*PI, 2, 3)
        if st_pt then
            st_pt = st_pt + pt
			local st = SpawnPrefab("dubloon")
			st.Transform:SetPosition(st_pt.x, st_pt.y, st_pt.z)
        end
		end

	if owner.components.hunger.current >= 2 then
        owner.components.hunger.current = owner.components.hunger.current - 1
	else
		owner.components.health.currenthealth = owner.components.health.currenthealth - 2
	end
	if owner.components.health and owner.components.health:GetPercent() < 1 and not target:HasTag("wall") then
        owner.components.health:DoDelta((damage+inst.soul * 1)*0.1)
		owner.components.hunger.current = owner.components.hunger.current - 1
    end
end

local function onsave(inst, data)
	data.soul = inst.soul
end

local function onpreload(inst, data)
	if data then
		if data.soul then
		inst.soul = data.soul
		inst.components.weapon:SetDamage(damage+inst.soul)
		end
	end
end
--get soul
local function onkilll(inst, data)
if not GetPlayer().components.health:IsDead() then

    if math.random() < 0.1 then
	inst.soul = inst.soul + 1
	inst.components.weapon:SetDamage(damage+inst.soul)
		do
		inst.components.talker:Say("[soul] \n".. (inst.soul))
		end
	end
	

	
end
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()	
    MakeInventoryPhysics(inst)
    inst.soul = 0
    anim:SetBank("nightmaresword")
    anim:SetBuild("scimitar")
    anim:PlayAnimation("idle")
    inst:AddComponent("tool")
	inst.components.tool:SetAction(ACTIONS.HACK,1)
    inst:AddTag("sharp")
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(damage+inst.soul * 1)
	inst.components.weapon:SetRange(TUNING.BOOMERANG_DISTANCE, TUNING.BOOMERANG_DISTANCE+2)
	inst.components.weapon.onattack = onattack

    -------
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/scimitar.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip)
	
	
	inst:AddComponent("talker")
	inst.components.talker.fontsize = 28
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(.9, .4, .4, 1)
    inst.components.talker.offset = Vector3(0,0,0)

    
    inst:AddComponent("characterspecific")
    inst.components.characterspecific:SetOwner("wili")
    
    

	
	inst:ListenForEvent("entity_death", function(wrld, data) onkilll(inst, data) end, GetWorld())
	inst.components.equippable.walkspeedmult = 1.1
	inst.OnSave = onsave
	inst.OnPreLoad = onpreload

    
    return inst
end

return Prefab( "common/inventory/scimitar", fn, assets)